unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Rtti, System.Classes,
  System.Variants, FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.Types3D,
  FMX.Objects3D, FMX.Materials, FMX.Layers3D;

type
  TForm1 = class(TForm3D)
    Light1: TLight;
    Camera1: TCamera;
    Timer1: TTimer;
    Layer3D1: TLayer3D;
    TrackBar1: TTrackBar;
    procedure Form3DShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Form3DClose(Sender: TObject; var Action: TCloseAction);
  private
    { private 錾 }
    stp1 : integer ;
    stp2 : single ;
  public
    { public 錾 }
  end;

var
  Form1: TForm1;
  mtrn: integer ;
  mtr : array of TLightMaterialSource;
  boxn: integer ;
  box : array of TCube ;

implementation

{$R *.fmx}

procedure TForm1.Form3DShow(Sender: TObject);
var
   i : integer ;
begin
   mtrn := 0 ;
   boxn := 0 ;
   for i := 0 to 99 do begin
      Inc(mtrn);
      if ((mtrn mod 20) = 1) then
         SetLength(mtr, mtrn+19);
      mtr[mtrn-1] := nil ;
      try
         mtr[mtrn-1] := TLightMaterialSource.Create(Self);
         mtr[mtrn-1].Name := 'Mtr' + IntToStr(mtrn) ;
         mtr[mtrn-1].Parent := Form1 ;
         mtr[mtrn-1].Diffuse := $FF000000 + Cardinal(Random(256) + Random(256)*256 + Random(256)*65536);
      except
         ;
      end;

      Inc(boxn);
      if ((boxn mod 20) = 1) then
         SetLength(box, boxn+19);
      box[boxn-1] := nil ;
      try
         box[boxn-1] := TCube.Create(Self);
         box[boxn-1].Visible := False ;
         box[boxn-1].Name := 'Cube' + IntToStr(boxn) ;
         box[boxn-1].Tag := boxn ;
         box[boxn-1].MaterialSource := mtr[mtrn-1] ;
         box[boxn-1].Parent := Form1 ;
         box[boxn-1].Position.X := (i mod 10)*1.5 - 6.75 ;
         box[boxn-1].Position.Y := 0 ;
         box[boxn-1].Position.Z := (i div 10)*1.5 - 6.75 ;
         box[boxn-1].Width := 1 ;
         box[boxn-1].Height:= 1 ;
         box[boxn-1].Depth := 1 ;
         box[boxn-1].Visible := True ;
      except
         ;
      end;
   end;

   stp1 := 0 ;
   stp2 := 0.0 ;
   Timer1.Interval := 100 ;
   Timer1.Enabled := True ;
end;

procedure TForm1.Form3DClose(Sender: TObject; var Action: TCloseAction);
var
   i : integer ;
begin
   for i := 0 to 99 do begin
      mtr[i] := nil ;
      box[i] := nil ;
   end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
   x,y,z : single ;
   i : integer ;
begin
   Timer1.Enabled := False ;

   case(stp1)of
   0: begin
         x :=  6 ;
         z := -6 + stp2 *0.12;
      end;
   1: begin
         x :=  6 - stp2 *0.12;
         z :=  6 ;
      end;
   2: begin
         x := -6 ;
         z :=  6 - stp2 *0.12;
      end;
   else begin
         x := -6 + stp2 *0.12;
         z := -6 ;
      end;
   end;
   y := TrackBar1.Value ;
   Camera1.Position.X := x ;
   Camera1.Position.Y := y ;
   Camera1.Position.Z := z ;

   stp2 := stp2 + 1.0;
   if (stp2 >= 100.0) then begin
      stp2 := 0.0;
      Inc(stp1);
      if (stp1 >= 4) then
         stp1 := 0;
      for i := 0 to 90 do begin
         Camera1.RotationAngle.Y := Camera1.RotationAngle.Y - 1.0 ;
         Application.ProcessMessages ;
      end;
   end;

   Timer1.Interval := 50 ;
   Timer1.Enabled := True ;
end;

end.
